vector-0.13.2.0: Efficient Arrays

Copyright | (c) Roman Leshchinskiy 2009-2010 Alexey Kuleshevich 2020-2022 Aleksey Khudyakov 2020-2022 Andrew Lelechenko 2020-2022
License | BSD-style
Maintainer | Haskell Libraries Team <libraries@haskell.org>
Stability | experimental
Portability | non-portable
Safe Haskell | None
Language | Haskell2010

Data.Vector.Storable.Mutable

Contents

- Mutable vectors of `Storable` types
- Accessors
  - Length information
  - Extracting subvectors
  - Overlapping
- Construction
  - Initialisation
  - Growing
  - Restricting memory usage
- Accessing individual elements
- Folds
- Modifying vectors
  - Filling and copying
- Unsafe conversions
- Raw pointers
- Re-exports

Description

Mutable vectors based on Storable.

Synopsis

- data MVector s a = MVector !Int !(ForeignPtr a)
- type IOVector = MVector RealWorld
- type STVector s = MVector s
- length :: Storable a => MVector s a -> Int
- null :: Storable a => MVector s a -> Bool
- slice :: Storable a => Int -> Int -> MVector s a -> MVector s a
- init :: Storable a => MVector s a -> MVector s a
- tail :: Storable a => MVector s a -> MVector s a
- take :: Storable a => Int -> MVector s a -> MVector s a
- drop :: Storable a => Int -> MVector s a -> MVector s a
- splitAt :: Storable a => Int -> MVector s a -> (MVector s a, MVector s a)
- unsafeSlice :: Storable a => Int -> Int -> MVector s a -> MVector s a
- unsafeInit :: Storable a => MVector s a -> MVector s a
- unsafeTail :: Storable a => MVector s a -> MVector s a
- unsafeTake :: Storable a => Int -> MVector s a -> MVector s a
- unsafeDrop :: Storable a => Int -> MVector s a -> MVector s a
- overlaps :: Storable a => MVector s a -> MVector s a -> Bool
- new :: (PrimMonad m, Storable a) => Int -> m (MVector (PrimState m) a)
- unsafeNew :: (PrimMonad m, Storable a) => Int -> m (MVector (PrimState m) a)
- replicate :: (PrimMonad m, Storable a) => Int -> a -> m (MVector (PrimState m) a)
- replicateM :: (PrimMonad m, Storable a) => Int -> m a -> m (MVector (PrimState m) a)
- generate :: (PrimMonad m, Storable a) => Int -> (Int -> a) -> m (MVector (PrimState m) a)
- generateM :: (PrimMonad m, Storable a) => Int -> (Int -> m a) -> m (MVector (PrimState m) a)
- clone :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> m (MVector (PrimState m) a)
- grow :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> Int -> m (MVector (PrimState m) a)
- unsafeGrow :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> Int -> m (MVector (PrimState m) a)
- clear :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> m ()
- read :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> Int -> m a
- readMaybe :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> Int -> m (Maybe a)
- write :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> Int -> a -> m ()
- modify :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> (a -> a) -> Int -> m ()
- modifyM :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> (a -> m a) -> Int -> m ()
- swap :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> Int -> Int -> m ()
- exchange :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> Int -> a -> m a
- unsafeRead :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> Int -> m a
- unsafeWrite :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> Int -> a -> m ()
- unsafeModify :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> (a -> a) -> Int -> m ()
- unsafeModifyM :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> (a -> m a) -> Int -> m ()
- unsafeSwap :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> Int -> Int -> m ()
- unsafeExchange :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> Int -> a -> m a
- mapM_ :: (PrimMonad m, Storable a) => (a -> m b) -> MVector (PrimState m) a -> m ()
- imapM_ :: (PrimMonad m, Storable a) => (Int -> a -> m b) -> MVector (PrimState m) a -> m ()
- forM_ :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> (a -> m b) -> m ()
- iforM_ :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> (Int -> a -> m b) -> m ()
- foldl :: (PrimMonad m, Storable a) => (b -> a -> b) -> b -> MVector (PrimState m) a -> m b
- foldl' :: (PrimMonad m, Storable a) => (b -> a -> b) -> b -> MVector (PrimState m) a -> m b
- foldM :: (PrimMonad m, Storable a) => (b -> a -> m b) -> b -> MVector (PrimState m) a -> m b
- foldM' :: (PrimMonad m, Storable a) => (b -> a -> m b) -> b -> MVector (PrimState m) a -> m b
- foldr :: (PrimMonad m, Storable a) => (a -> b -> b) -> b -> MVector (PrimState m) a -> m b
- foldr' :: (PrimMonad m, Storable a) => (a -> b -> b) -> b -> MVector (PrimState m) a -> m b
- foldrM :: (PrimMonad m, Storable a) => (a -> b -> m b) -> b -> MVector (PrimState m) a -> m b
- foldrM' :: (PrimMonad m, Storable a) => (a -> b -> m b) -> b -> MVector (PrimState m) a -> m b
- ifoldl :: (PrimMonad m, Storable a) => (b -> Int -> a -> b) -> b -> MVector (PrimState m) a -> m b
- ifoldl' :: (PrimMonad m, Storable a) => (b -> Int -> a -> b) -> b -> MVector (PrimState m) a -> m b
- ifoldM :: (PrimMonad m, Storable a) => (b -> Int -> a -> m b) -> b -> MVector (PrimState m) a -> m b
- ifoldM' :: (PrimMonad m, Storable a) => (b -> Int -> a -> m b) -> b -> MVector (PrimState m) a -> m b
- ifoldr :: (PrimMonad m, Storable a) => (Int -> a -> b -> b) -> b -> MVector (PrimState m) a -> m b
- ifoldr' :: (PrimMonad m, Storable a) => (Int -> a -> b -> b) -> b -> MVector (PrimState m) a -> m b
- ifoldrM :: (PrimMonad m, Storable a) => (Int -> a -> b -> m b) -> b -> MVector (PrimState m) a -> m b
- ifoldrM' :: (PrimMonad m, Storable a) => (Int -> a -> b -> m b) -> b -> MVector (PrimState m) a -> m b
- nextPermutation :: (PrimMonad m, Storable e, Ord e) => MVector (PrimState m) e -> m Bool
- nextPermutationBy :: (PrimMonad m, Storable e) => (e -> e -> Ordering) -> MVector (PrimState m) e -> m Bool
- prevPermutation :: (PrimMonad m, Storable e, Ord e) => MVector (PrimState m) e -> m Bool
- prevPermutationBy :: (PrimMonad m, Storable e) => (e -> e -> Ordering) -> MVector (PrimState m) e -> m Bool
- set :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> a -> m ()
- copy :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> MVector (PrimState m) a -> m ()
- move :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> MVector (PrimState m) a -> m ()
- unsafeCopy :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> MVector (PrimState m) a -> m ()
- unsafeMove :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> MVector (PrimState m) a -> m ()
- unsafeCast :: (Storable a, Storable b) => MVector s a -> MVector s b
- unsafeCoerceMVector :: Coercible a b => MVector s a -> MVector s b
- unsafeFromForeignPtr :: Storable a => ForeignPtr a -> Int -> Int -> MVector s a
- unsafeFromForeignPtr0 :: ForeignPtr a -> Int -> MVector s a
- unsafeToForeignPtr :: MVector s a -> (ForeignPtr a, Int, Int)
- unsafeToForeignPtr0 :: MVector s a -> (ForeignPtr a, Int)
- unsafeWith :: Storable a => IOVector a -> (Ptr a -> IO b) -> IO b
- class Storable a
- class Monad m => PrimMonad (m :: Type -> Type)
- type family PrimState (m :: Type -> Type)
- data RealWorld

# Mutable vectors of `Storable` types

data MVector s a Source #

Mutable `Storable`-based vectors.

Constructors

MVector !Int !(ForeignPtr a) |

#### Instances

Instances details

Storable a => MVector MVector a Source # |

Instance details

Defined in Data.Vector.Storable.Mutable

Methods

basicLength :: MVector s a -> Int Source #

basicUnsafeSlice :: Int -> Int -> MVector s a -> MVector s a Source #

basicOverlaps :: MVector s a -> MVector s a -> Bool Source #

basicUnsafeNew :: Int -> ST s (MVector s a) Source #

basicInitialize :: MVector s a -> ST s () Source #

basicUnsafeReplicate :: Int -> a -> ST s (MVector s a) Source #

basicUnsafeRead :: MVector s a -> Int -> ST s a Source #

basicUnsafeWrite :: MVector s a -> Int -> a -> ST s () Source #

basicClear :: MVector s a -> ST s () Source #

basicSet :: MVector s a -> a -> ST s () Source #

basicUnsafeCopy :: MVector s a -> MVector s a -> ST s () Source #

basicUnsafeMove :: MVector s a -> MVector s a -> ST s () Source #

basicUnsafeGrow :: MVector s a -> Int -> ST s (MVector s a) Source #

NFData1 (MVector s) Source # |
Instance details Defined in Data.Vector.Storable.Mutable Methods liftRnf :: (a -> ()) -> MVector s a -> () Source #
NFData (MVector s a) Source # |
Instance details Defined in Data.Vector.Storable.Mutable Methods rnf :: MVector s a -> () Source #

type IOVector = MVector RealWorld Source #

type STVector s = MVector s Source #

# Accessors

## Length information

length :: Storable a => MVector s a -> Int Source #

Length of the mutable vector.

null :: Storable a => MVector s a -> Bool Source #

Check whether the vector is empty.

## Extracting subvectors

slice Source #

Arguments

:: Storable a |
=> Int | `i` starting index
-> Int | `n` length
-> MVector s a |
-> MVector s a |

Yield a part of the mutable vector without copying it. The vector must contain at least `i+n` elements.

init :: Storable a => MVector s a -> MVector s a Source #

Drop the last element of the mutable vector without making a copy. If the vector is empty, an exception is thrown.

tail :: Storable a => MVector s a -> MVector s a Source #

Drop the first element of the mutable vector without making a copy. If the vector is empty, an exception is thrown.

take :: Storable a => Int -> MVector s a -> MVector s a Source #

Take the `n` first elements of the mutable vector without making a copy. For negative `n`, the empty vector is returned. If `n` is larger than the vector's length, the vector is returned unchanged.

drop :: Storable a => Int -> MVector s a -> MVector s a Source #

Drop the `n` first element of the mutable vector without making a copy. For negative `n`, the vector is returned unchanged. If `n` is larger than the vector's length, the empty vector is returned.

splitAt :: Storable a => Int -> MVector s a -> (MVector s a, MVector s a) Source #

O(1) Split the mutable vector into the first `n` elements and the remainder, without copying.

Note that ``splitAt` n v` is equivalent to `(`take` n v, `drop` n v)`, but slightly more efficient.

unsafeSlice Source #

Arguments

:: Storable a |
=> Int | starting index
-> Int | length of the slice
-> MVector s a |
-> MVector s a |

Yield a part of the mutable vector without copying it. No bounds checks are performed.

unsafeInit :: Storable a => MVector s a -> MVector s a Source #

Same as `init`, but doesn't do range checks.

unsafeTail :: Storable a => MVector s a -> MVector s a Source #

Same as `tail`, but doesn't do range checks.

unsafeTake :: Storable a => Int -> MVector s a -> MVector s a Source #

Unsafe variant of `take`. If `n` is out of range, it will simply create an invalid slice that likely violate memory safety.

unsafeDrop :: Storable a => Int -> MVector s a -> MVector s a Source #

Unsafe variant of `drop`. If `n` is out of range, it will simply create an invalid slice that likely violate memory safety.

## Overlapping

overlaps :: Storable a => MVector s a -> MVector s a -> Bool Source #

Check whether two vectors overlap.

# Construction

## Initialisation

new :: (PrimMonad m, Storable a) => Int -> m (MVector (PrimState m) a) Source #

Create a mutable vector of the given length.

unsafeNew :: (PrimMonad m, Storable a) => Int -> m (MVector (PrimState m) a) Source #

Create a mutable vector of the given length. The vector content is uninitialized, which means it is filled with whatever the underlying memory buffer happens to contain.

Since: 0.5

replicate :: (PrimMonad m, Storable a) => Int -> a -> m (MVector (PrimState m) a) Source #

Create a mutable vector of the given length (0 if the length is negative) and fill it with an initial value.

replicateM :: (PrimMonad m, Storable a) => Int -> m a -> m (MVector (PrimState m) a) Source #

Create a mutable vector of the given length (0 if the length is negative) and fill it with values produced by repeatedly executing the monadic action.

generate :: (PrimMonad m, Storable a) => Int -> (Int -> a) -> m (MVector (PrimState m) a) Source #

O(n) Create a mutable vector of the given length (0 if the length is negative) and fill it with the results of applying the function to each index. Iteration starts at index 0.

Since: 0.12.3.0

generateM :: (PrimMonad m, Storable a) => Int -> (Int -> m a) -> m (MVector (PrimState m) a) Source #

O(n) Create a mutable vector of the given length (0 if the length is negative) and fill it with the results of applying the monadic function to each index. Iteration starts at index 0.

Since: 0.12.3.0

clone :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> m (MVector (PrimState m) a) Source #

Create a copy of a mutable vector.

## Growing

grow :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> Int -> m (MVector (PrimState m) a) Source #

Grow a storable vector by the given number of elements. The number must be non-negative. This has the same semantics as `grow` for generic vectors.

#### Examples

Expand

    >>> import qualified Data.Vector.Storable as VS
    >>> import qualified Data.Vector.Storable.Mutable as MVS
    >>> mv <- VS.thaw $ VS.fromList ([10, 20, 30] :: [Int])
    >>> mv' <- MVS.grow mv 2

Extra memory at the end of the newly allocated vector is initialized to 0 bytes, which for `Storable` instances will usually correspond to some default value for a particular type, e.g. `0` for `Int`, `False` for `Bool`, etc. However, if `unsafeGrow` was used instead, this would not have been guaranteed and some garbage would be there instead.

    >>> VS.freeze mv'
    [10,20,30,0,0]

Having the extra space we can write new values in there:

    >>> MVS.write mv' 3 999
    >>> VS.freeze mv'
    [10,20,30,999,0]

It is important to note that the source mutable vector is not affected when the newly allocated one is mutated.

    >>> MVS.write mv' 2 888
    >>> VS.freeze mv'
    [10,20,888,999,0]
    >>> VS.freeze mv
    [10,20,30]

Since: 0.5

unsafeGrow :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> Int -> m (MVector (PrimState m) a) Source #

Grow a vector by the given number of elements. The number must be non-negative, but this is not checked. This has the same semantics as `unsafeGrow` for generic vectors.

Since: 0.5

## Restricting memory usage

clear :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> m () Source #

Reset all elements of the vector to some undefined value, clearing all references to external objects. This is a noop.

# Accessing individual elements

read :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> Int -> m a Source #

Yield the element at the given position. Will throw an exception if the index is out of range.

#### Examples

Expand

    >>> import qualified Data.Vector.Storable.Mutable as MVS
    >>> v <- MVS.generate 10 (\x -> x*x)
    >>> MVS.read v 3
    9

readMaybe :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> Int -> m (Maybe a) Source #

Yield the element at the given position. Returns `Nothing` if the index is out of range.

#### Examples

Expand

    >>> import qualified Data.Vector.Storable.Mutable as MVS
    >>> v <- MVS.generate 10 (\x -> x*x)
    >>> MVS.readMaybe v 3
    Just 9
    >>> MVS.readMaybe v 13
    Nothing

Since: 0.13

write :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> Int -> a -> m () Source #

Replace the element at the given position.

modify :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> (a -> a) -> Int -> m () Source #

Modify the element at the given position.

modifyM :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> (a -> m a) -> Int -> m () Source #

Modify the element at the given position using a monadic function.

Since: 0.12.3.0

swap :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> Int -> Int -> m () Source #

Swap the elements at the given positions.

exchange :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> Int -> a -> m a Source #

Replace the element at the given position and return the old element.

unsafeRead :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> Int -> m a Source #

Yield the element at the given position. No bounds checks are performed.

unsafeWrite :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> Int -> a -> m () Source #

Replace the element at the given position. No bounds checks are performed.

unsafeModify :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> (a -> a) -> Int -> m () Source #

Modify the element at the given position. No bounds checks are performed.

unsafeModifyM :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> (a -> m a) -> Int -> m () Source #

Modify the element at the given position using a monadic function. No bounds checks are performed.

Since: 0.12.3.0

unsafeSwap :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> Int -> Int -> m () Source #

Swap the elements at the given positions. No bounds checks are performed.

unsafeExchange :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> Int -> a -> m a Source #

Replace the element at the given position and return the old element. No bounds checks are performed.

# Folds

mapM_ :: (PrimMonad m, Storable a) => (a -> m b) -> MVector (PrimState m) a -> m () Source #

O(n) Apply the monadic action to every element of the vector, discarding the results.

Since: 0.12.3.0

imapM_ :: (PrimMonad m, Storable a) => (Int -> a -> m b) -> MVector (PrimState m) a -> m () Source #

O(n) Apply the monadic action to every element of the vector and its index, discarding the results.

Since: 0.12.3.0

forM_ :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> (a -> m b) -> m () Source #

O(n) Apply the monadic action to every element of the vector, discarding the results. It's the same as `flip mapM_`.

Since: 0.12.3.0

iforM_ :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> (Int -> a -> m b) -> m () Source #

O(n) Apply the monadic action to every element of the vector and its index, discarding the results. It's the same as `flip imapM_`.

Since: 0.12.3.0

foldl :: (PrimMonad m, Storable a) => (b -> a -> b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Pure left fold.

Since: 0.12.3.0

foldl' :: (PrimMonad m, Storable a) => (b -> a -> b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Pure left fold with strict accumulator.

Since: 0.12.3.0

foldM :: (PrimMonad m, Storable a) => (b -> a -> m b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Monadic fold.

Since: 0.12.3.0

foldM' :: (PrimMonad m, Storable a) => (b -> a -> m b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Monadic fold with strict accumulator.

Since: 0.12.3.0

foldr :: (PrimMonad m, Storable a) => (a -> b -> b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Pure right fold.

Since: 0.12.3.0

foldr' :: (PrimMonad m, Storable a) => (a -> b -> b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Pure right fold with strict accumulator.

Since: 0.12.3.0

foldrM :: (PrimMonad m, Storable a) => (a -> b -> m b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Monadic right fold.

Since: 0.12.3.0

foldrM' :: (PrimMonad m, Storable a) => (a -> b -> m b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Monadic right fold with strict accumulator.

Since: 0.12.3.0

ifoldl :: (PrimMonad m, Storable a) => (b -> Int -> a -> b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Pure left fold using a function applied to each element and its index.

Since: 0.12.3.0

ifoldl' :: (PrimMonad m, Storable a) => (b -> Int -> a -> b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Pure left fold with strict accumulator using a function applied to each element and its index.

Since: 0.12.3.0

ifoldM :: (PrimMonad m, Storable a) => (b -> Int -> a -> m b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Monadic fold using a function applied to each element and its index.

Since: 0.12.3.0

ifoldM' :: (PrimMonad m, Storable a) => (b -> Int -> a -> m b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Monadic fold with strict accumulator using a function applied to each element and its index.

Since: 0.12.3.0

ifoldr :: (PrimMonad m, Storable a) => (Int -> a -> b -> b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Pure right fold using a function applied to each element and its index.

Since: 0.12.3.0

ifoldr' :: (PrimMonad m, Storable a) => (Int -> a -> b -> b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Pure right fold with strict accumulator using a function applied to each element and its index.

Since: 0.12.3.0

ifoldrM :: (PrimMonad m, Storable a) => (Int -> a -> b -> m b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Monadic right fold using a function applied to each element and its index.

Since: 0.12.3.0

ifoldrM' :: (PrimMonad m, Storable a) => (Int -> a -> b -> m b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Monadic right fold with strict accumulator using a function applied to each element and its index.

Since: 0.12.3.0

# Modifying vectors

nextPermutation :: (PrimMonad m, Storable e, Ord e) => MVector (PrimState m) e -> m Bool Source #

Compute the (lexicographically) next permutation of the given vector in-place. Returns False when the input is the last item in the enumeration, i.e., if it is in weakly descending order. In this case the vector will not get updated, as opposed to the behavior of the C++ function `std::next_permutation`.

nextPermutationBy :: (PrimMonad m, Storable e) => (e -> e -> Ordering) -> MVector (PrimState m) e -> m Bool Source #

Compute the (lexicographically) next permutation of the given vector in-place, using the provided comparison function. Returns False when the input is the last item in the enumeration, i.e., if it is in weakly descending order. In this case the vector will not get updated, as opposed to the behavior of the C++ function `std::next_permutation`.

Since: 0.13.2.0

prevPermutation :: (PrimMonad m, Storable e, Ord e) => MVector (PrimState m) e -> m Bool Source #

Compute the (lexicographically) previous permutation of the given vector in-place. Returns False when the input is the last item in the enumeration, i.e., if it is in weakly ascending order. In this case the vector will not get updated, as opposed to the behavior of the C++ function `std::prev_permutation`.

Since: 0.13.2.0

prevPermutationBy :: (PrimMonad m, Storable e) => (e -> e -> Ordering) -> MVector (PrimState m) e -> m Bool Source #

Compute the (lexicographically) previous permutation of the given vector in-place, using the provided comparison function. Returns False when the input is the last item in the enumeration, i.e., if it is in weakly ascending order. In this case the vector will not get updated, as opposed to the behavior of the C++ function `std::prev_permutation`.

Since: 0.13.2.0

## Filling and copying

set :: (PrimMonad m, Storable a) => MVector (PrimState m) a -> a -> m () Source #

Set all elements of the vector to the given value.

copy Source #

Arguments

:: (PrimMonad m, Storable a) |
=> MVector (PrimState m) a | target
-> MVector (PrimState m) a | source
-> m () |

Copy a vector. The two vectors must have the same length and may not overlap.

move Source #

Arguments

:: (PrimMonad m, Storable a) |
=> MVector (PrimState m) a | target
-> MVector (PrimState m) a | source
-> m () |

Move the contents of a vector. The two vectors must have the same length.

If the vectors do not overlap, then this is equivalent to `copy`. Otherwise, the copying is performed as if the source vector were copied to a temporary vector and then the temporary vector was copied to the target vector.

unsafeCopy Source #

Arguments

:: (PrimMonad m, Storable a) |
=> MVector (PrimState m) a | target
-> MVector (PrimState m) a | source
-> m () |

Copy a vector. The two vectors must have the same length and may not overlap, but this is not checked.

unsafeMove Source #

Arguments

:: (PrimMonad m, Storable a) |
=> MVector (PrimState m) a | target
-> MVector (PrimState m) a | source
-> m () |

Move the contents of a vector. The two vectors must have the same length, but this is not checked.

If the vectors do not overlap, then this is equivalent to `unsafeCopy`. Otherwise, the copying is performed as if the source vector were copied to a temporary vector and then the temporary vector was copied to the target vector.

# Unsafe conversions

unsafeCast :: (Storable a, Storable b) => MVector s a -> MVector s b Source #

O(1) Unsafely cast a mutable vector from one element type to another. The operation just changes the type of the underlying pointer and does not modify the elements.

The resulting vector contains as many elements as can fit into the underlying memory block.

unsafeCoerceMVector :: Coercible a b => MVector s a -> MVector s b Source #

O(1) Unsafely coerce a mutable vector from one element type to another, representationally equal type. The operation just changes the type of the underlying pointer and does not modify the elements.

This is marginally safer than `unsafeCast`, since this function imposes an extra `Coercible` constraint. This function is still not safe, however, since it cannot guarantee that the two types have memory-compatible `Storable` instances.

# Raw pointers

unsafeFromForeignPtr Source #

Arguments

:: Storable a |
=> ForeignPtr a | pointer
-> Int | offset
-> Int | length
-> MVector s a |

O(1) Create a mutable vector from a `ForeignPtr` with an offset and a length.

Modifying data through the `ForeignPtr` afterwards is unsafe if the vector could have been frozen before the modification.

If your offset is 0, it is more efficient to use `unsafeFromForeignPtr0`.

unsafeFromForeignPtr0 Source #

Arguments

:: ForeignPtr a | pointer
-> Int | length
-> MVector s a |

O(1) Create a mutable vector from a `ForeignPtr` and a length.

It is assumed that the pointer points directly to the data (no offset). Use `unsafeFromForeignPtr` if you need to specify an offset.

Modifying data through the `ForeignPtr` afterwards is unsafe if the vector could have been frozen before the modification.

unsafeToForeignPtr :: MVector s a -> (ForeignPtr a, Int, Int) Source #

O(1) Yield the underlying `ForeignPtr` together with the offset to the data and its length. Modifying the data through the `ForeignPtr` is unsafe if the vector could have been frozen before the modification.

unsafeToForeignPtr0 :: MVector s a -> (ForeignPtr a, Int) Source #

O(1) Yield the underlying `ForeignPtr` together with its length.

You can assume that the pointer points directly to the data (no offset).

Modifying the data through the `ForeignPtr` is unsafe if the vector could have been frozen before the modification.

unsafeWith :: Storable a => IOVector a -> (Ptr a -> IO b) -> IO b Source #

Pass a pointer to the vector's data to the IO action. Modifying data through the pointer is unsafe if the vector could have been frozen before the modification.

# Re-exports

class Storable a Source #

The member functions of this class facilitate writing values of primitive types to raw memory (which may have been allocated with the above mentioned routines) and reading values from blocks of raw memory. The class, furthermore, includes support for computing the storage requirements and alignment restrictions of storable types.

Memory addresses are represented as values of type ``Ptr` a`, for some `a` which is an instance of class `Storable`. The type argument to `Ptr` helps provide some valuable type safety in FFI code (you can't mix pointers of different types without an explicit cast), while helping the Haskell type system figure out which marshalling method is needed for a given pointer.

All marshalling between Haskell and a foreign language ultimately boils down to translating Haskell data structures into the binary representation of a corresponding data structure of the foreign language and vice versa. To code this marshalling in Haskell, it is necessary to manipulate primitive data types stored in unstructured memory blocks. The class `Storable` facilitates this manipulation on all types for which it is instantiated, which are the standard basic types of Haskell, the fixed size `Int` types (`Int8`, `Int16`, `Int32`, `Int64`), the fixed size `Word` types (`Word8`, `Word16`, `Word32`, `Word64`), `StablePtr`, all types from Foreign.C.Types, as well as `Ptr`.

Minimal complete definition

sizeOf, alignment, (peek | peekElemOff | peekByteOff), (poke | pokeElemOff | pokeByteOff)

#### Instances

Instances details

Storable Fingerprint | Since: base-4.4.0.0

Instance details

Defined in GHC.Internal.Foreign.Storable

Methods

sizeOf :: Fingerprint -> Int Source #

alignment :: Fingerprint -> Int Source #

peekElemOff :: Ptr Fingerprint -> Int -> IO Fingerprint Source #

pokeElemOff :: Ptr Fingerprint -> Int -> Fingerprint -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Fingerprint Source #

pokeByteOff :: Ptr b -> Int -> Fingerprint -> IO () Source #

peek :: Ptr Fingerprint -> IO Fingerprint Source #

poke :: Ptr Fingerprint -> Fingerprint -> IO () Source #

Storable CBool |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CBool -> Int Source #

alignment :: CBool -> Int Source #

peekElemOff :: Ptr CBool -> Int -> IO CBool Source #

pokeElemOff :: Ptr CBool -> Int -> CBool -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CBool Source #

pokeByteOff :: Ptr b -> Int -> CBool -> IO () Source #

peek :: Ptr CBool -> IO CBool Source #

poke :: Ptr CBool -> CBool -> IO () Source #

Storable CChar |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CChar -> Int Source #

alignment :: CChar -> Int Source #

peekElemOff :: Ptr CChar -> Int -> IO CChar Source #

pokeElemOff :: Ptr CChar -> Int -> CChar -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CChar Source #

pokeByteOff :: Ptr b -> Int -> CChar -> IO () Source #

peek :: Ptr CChar -> IO CChar Source #

poke :: Ptr CChar -> CChar -> IO () Source #

Storable CClock |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CClock -> Int Source #

alignment :: CClock -> Int Source #

peekElemOff :: Ptr CClock -> Int -> IO CClock Source #

pokeElemOff :: Ptr CClock -> Int -> CClock -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CClock Source #

pokeByteOff :: Ptr b -> Int -> CClock -> IO () Source #

peek :: Ptr CClock -> IO CClock Source #

poke :: Ptr CClock -> CClock -> IO () Source #

Storable CDouble |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CDouble -> Int Source #

alignment :: CDouble -> Int Source #

peekElemOff :: Ptr CDouble -> Int -> IO CDouble Source #

pokeElemOff :: Ptr CDouble -> Int -> CDouble -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CDouble Source #

pokeByteOff :: Ptr b -> Int -> CDouble -> IO () Source #

peek :: Ptr CDouble -> IO CDouble Source #

poke :: Ptr CDouble -> CDouble -> IO () Source #

Storable CFloat |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CFloat -> Int Source #

alignment :: CFloat -> Int Source #

peekElemOff :: Ptr CFloat -> Int -> IO CFloat Source #

pokeElemOff :: Ptr CFloat -> Int -> CFloat -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CFloat Source #

pokeByteOff :: Ptr b -> Int -> CFloat -> IO () Source #

peek :: Ptr CFloat -> IO CFloat Source #

poke :: Ptr CFloat -> CFloat -> IO () Source #

Storable CInt |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CInt -> Int Source #

alignment :: CInt -> Int Source #

peekElemOff :: Ptr CInt -> Int -> IO CInt Source #

pokeElemOff :: Ptr CInt -> Int -> CInt -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CInt Source #

pokeByteOff :: Ptr b -> Int -> CInt -> IO () Source #

peek :: Ptr CInt -> IO CInt Source #

poke :: Ptr CInt -> CInt -> IO () Source #

Storable CIntMax |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CIntMax -> Int Source #

alignment :: CIntMax -> Int Source #

peekElemOff :: Ptr CIntMax -> Int -> IO CIntMax Source #

pokeElemOff :: Ptr CIntMax -> Int -> CIntMax -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CIntMax Source #

pokeByteOff :: Ptr b -> Int -> CIntMax -> IO () Source #

peek :: Ptr CIntMax -> IO CIntMax Source #

poke :: Ptr CIntMax -> CIntMax -> IO () Source #

Storable CIntPtr |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CIntPtr -> Int Source #

alignment :: CIntPtr -> Int Source #

peekElemOff :: Ptr CIntPtr -> Int -> IO CIntPtr Source #

pokeElemOff :: Ptr CIntPtr -> Int -> CIntPtr -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CIntPtr Source #

pokeByteOff :: Ptr b -> Int -> CIntPtr -> IO () Source #

peek :: Ptr CIntPtr -> IO CIntPtr Source #

poke :: Ptr CIntPtr -> CIntPtr -> IO () Source #

Storable CLLong |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CLLong -> Int Source #

alignment :: CLLong -> Int Source #

peekElemOff :: Ptr CLLong -> Int -> IO CLLong Source #

pokeElemOff :: Ptr CLLong -> Int -> CLLong -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CLLong Source #

pokeByteOff :: Ptr b -> Int -> CLLong -> IO () Source #

peek :: Ptr CLLong -> IO CLLong Source #

poke :: Ptr CLLong -> CLLong -> IO () Source #

Storable CLong |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CLong -> Int Source #

alignment :: CLong -> Int Source #

peekElemOff :: Ptr CLong -> Int -> IO CLong Source #

pokeElemOff :: Ptr CLong -> Int -> CLong -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CLong Source #

pokeByteOff :: Ptr b -> Int -> CLong -> IO () Source #

peek :: Ptr CLong -> IO CLong Source #

poke :: Ptr CLong -> CLong -> IO () Source #

Storable CPtrdiff |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CPtrdiff -> Int Source #

alignment :: CPtrdiff -> Int Source #

peekElemOff :: Ptr CPtrdiff -> Int -> IO CPtrdiff Source #

pokeElemOff :: Ptr CPtrdiff -> Int -> CPtrdiff -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CPtrdiff Source #

pokeByteOff :: Ptr b -> Int -> CPtrdiff -> IO () Source #

peek :: Ptr CPtrdiff -> IO CPtrdiff Source #

poke :: Ptr CPtrdiff -> CPtrdiff -> IO () Source #

Storable CSChar |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CSChar -> Int Source #

alignment :: CSChar -> Int Source #

peekElemOff :: Ptr CSChar -> Int -> IO CSChar Source #

pokeElemOff :: Ptr CSChar -> Int -> CSChar -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CSChar Source #

pokeByteOff :: Ptr b -> Int -> CSChar -> IO () Source #

peek :: Ptr CSChar -> IO CSChar Source #

poke :: Ptr CSChar -> CSChar -> IO () Source #

Storable CSUSeconds |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CSUSeconds -> Int Source #

alignment :: CSUSeconds -> Int Source #

peekElemOff :: Ptr CSUSeconds -> Int -> IO CSUSeconds Source #

pokeElemOff :: Ptr CSUSeconds -> Int -> CSUSeconds -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CSUSeconds Source #

pokeByteOff :: Ptr b -> Int -> CSUSeconds -> IO () Source #

peek :: Ptr CSUSeconds -> IO CSUSeconds Source #

poke :: Ptr CSUSeconds -> CSUSeconds -> IO () Source #

Storable CShort |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CShort -> Int Source #

alignment :: CShort -> Int Source #

peekElemOff :: Ptr CShort -> Int -> IO CShort Source #

pokeElemOff :: Ptr CShort -> Int -> CShort -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CShort Source #

pokeByteOff :: Ptr b -> Int -> CShort -> IO () Source #

peek :: Ptr CShort -> IO CShort Source #

poke :: Ptr CShort -> CShort -> IO () Source #

Storable CSigAtomic |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CSigAtomic -> Int Source #

alignment :: CSigAtomic -> Int Source #

peekElemOff :: Ptr CSigAtomic -> Int -> IO CSigAtomic Source #

pokeElemOff :: Ptr CSigAtomic -> Int -> CSigAtomic -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CSigAtomic Source #

pokeByteOff :: Ptr b -> Int -> CSigAtomic -> IO () Source #

peek :: Ptr CSigAtomic -> IO CSigAtomic Source #

poke :: Ptr CSigAtomic -> CSigAtomic -> IO () Source #

Storable CSize |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CSize -> Int Source #

alignment :: CSize -> Int Source #

peekElemOff :: Ptr CSize -> Int -> IO CSize Source #

pokeElemOff :: Ptr CSize -> Int -> CSize -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CSize Source #

pokeByteOff :: Ptr b -> Int -> CSize -> IO () Source #

peek :: Ptr CSize -> IO CSize Source #

poke :: Ptr CSize -> CSize -> IO () Source #

Storable CTime |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CTime -> Int Source #

alignment :: CTime -> Int Source #

peekElemOff :: Ptr CTime -> Int -> IO CTime Source #

pokeElemOff :: Ptr CTime -> Int -> CTime -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CTime Source #

pokeByteOff :: Ptr b -> Int -> CTime -> IO () Source #

peek :: Ptr CTime -> IO CTime Source #

poke :: Ptr CTime -> CTime -> IO () Source #

Storable CUChar |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CUChar -> Int Source #

alignment :: CUChar -> Int Source #

peekElemOff :: Ptr CUChar -> Int -> IO CUChar Source #

pokeElemOff :: Ptr CUChar -> Int -> CUChar -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CUChar Source #

pokeByteOff :: Ptr b -> Int -> CUChar -> IO () Source #

peek :: Ptr CUChar -> IO CUChar Source #

poke :: Ptr CUChar -> CUChar -> IO () Source #

Storable CUInt |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CUInt -> Int Source #

alignment :: CUInt -> Int Source #

peekElemOff :: Ptr CUInt -> Int -> IO CUInt Source #

pokeElemOff :: Ptr CUInt -> Int -> CUInt -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CUInt Source #

pokeByteOff :: Ptr b -> Int -> CUInt -> IO () Source #

peek :: Ptr CUInt -> IO CUInt Source #

poke :: Ptr CUInt -> CUInt -> IO () Source #

Storable CUIntMax |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CUIntMax -> Int Source #

alignment :: CUIntMax -> Int Source #

peekElemOff :: Ptr CUIntMax -> Int -> IO CUIntMax Source #

pokeElemOff :: Ptr CUIntMax -> Int -> CUIntMax -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CUIntMax Source #

pokeByteOff :: Ptr b -> Int -> CUIntMax -> IO () Source #

peek :: Ptr CUIntMax -> IO CUIntMax Source #

poke :: Ptr CUIntMax -> CUIntMax -> IO () Source #

Storable CUIntPtr |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CUIntPtr -> Int Source #

alignment :: CUIntPtr -> Int Source #

peekElemOff :: Ptr CUIntPtr -> Int -> IO CUIntPtr Source #

pokeElemOff :: Ptr CUIntPtr -> Int -> CUIntPtr -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CUIntPtr Source #

pokeByteOff :: Ptr b -> Int -> CUIntPtr -> IO () Source #

peek :: Ptr CUIntPtr -> IO CUIntPtr Source #

poke :: Ptr CUIntPtr -> CUIntPtr -> IO () Source #

Storable CULLong |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CULLong -> Int Source #

alignment :: CULLong -> Int Source #

peekElemOff :: Ptr CULLong -> Int -> IO CULLong Source #

pokeElemOff :: Ptr CULLong -> Int -> CULLong -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CULLong Source #

pokeByteOff :: Ptr b -> Int -> CULLong -> IO () Source #

peek :: Ptr CULLong -> IO CULLong Source #

poke :: Ptr CULLong -> CULLong -> IO () Source #

Storable CULong |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CULong -> Int Source #

alignment :: CULong -> Int Source #

peekElemOff :: Ptr CULong -> Int -> IO CULong Source #

pokeElemOff :: Ptr CULong -> Int -> CULong -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CULong Source #

pokeByteOff :: Ptr b -> Int -> CULong -> IO () Source #

peek :: Ptr CULong -> IO CULong Source #

poke :: Ptr CULong -> CULong -> IO () Source #

Storable CUSeconds |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CUSeconds -> Int Source #

alignment :: CUSeconds -> Int Source #

peekElemOff :: Ptr CUSeconds -> Int -> IO CUSeconds Source #

pokeElemOff :: Ptr CUSeconds -> Int -> CUSeconds -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CUSeconds Source #

pokeByteOff :: Ptr b -> Int -> CUSeconds -> IO () Source #

peek :: Ptr CUSeconds -> IO CUSeconds Source #

poke :: Ptr CUSeconds -> CUSeconds -> IO () Source #

Storable CUShort |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CUShort -> Int Source #

alignment :: CUShort -> Int Source #

peekElemOff :: Ptr CUShort -> Int -> IO CUShort Source #

pokeElemOff :: Ptr CUShort -> Int -> CUShort -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CUShort Source #

pokeByteOff :: Ptr b -> Int -> CUShort -> IO () Source #

peek :: Ptr CUShort -> IO CUShort Source #

poke :: Ptr CUShort -> CUShort -> IO () Source #

Storable CWchar |

Instance details

Defined in GHC.Internal.Foreign.C.Types

Methods

sizeOf :: CWchar -> Int Source #

alignment :: CWchar -> Int Source #

peekElemOff :: Ptr CWchar -> Int -> IO CWchar Source #

pokeElemOff :: Ptr CWchar -> Int -> CWchar -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CWchar Source #

pokeByteOff :: Ptr b -> Int -> CWchar -> IO () Source #

peek :: Ptr CWchar -> IO CWchar Source #

poke :: Ptr CWchar -> CWchar -> IO () Source #

Storable IntPtr |

Instance details

Defined in GHC.Internal.Foreign.Ptr

Methods

sizeOf :: IntPtr -> Int Source #

alignment :: IntPtr -> Int Source #

peekElemOff :: Ptr IntPtr -> Int -> IO IntPtr Source #

pokeElemOff :: Ptr IntPtr -> Int -> IntPtr -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO IntPtr Source #

pokeByteOff :: Ptr b -> Int -> IntPtr -> IO () Source #

peek :: Ptr IntPtr -> IO IntPtr Source #

poke :: Ptr IntPtr -> IntPtr -> IO () Source #

Storable WordPtr |

Instance details

Defined in GHC.Internal.Foreign.Ptr

Methods

sizeOf :: WordPtr -> Int Source #

alignment :: WordPtr -> Int Source #

peekElemOff :: Ptr WordPtr -> Int -> IO WordPtr Source #

pokeElemOff :: Ptr WordPtr -> Int -> WordPtr -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO WordPtr Source #

pokeByteOff :: Ptr b -> Int -> WordPtr -> IO () Source #

peek :: Ptr WordPtr -> IO WordPtr Source #

poke :: Ptr WordPtr -> WordPtr -> IO () Source #

Storable Int16 | Since: base-2.1

Instance details

Defined in GHC.Internal.Foreign.Storable

Methods

sizeOf :: Int16 -> Int Source #

alignment :: Int16 -> Int Source #

peekElemOff :: Ptr Int16 -> Int -> IO Int16 Source #

pokeElemOff :: Ptr Int16 -> Int -> Int16 -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Int16 Source #

pokeByteOff :: Ptr b -> Int -> Int16 -> IO () Source #

peek :: Ptr Int16 -> IO Int16 Source #

poke :: Ptr Int16 -> Int16 -> IO () Source #

Storable Int32 | Since: base-2.1

Instance details

Defined in GHC.Internal.Foreign.Storable

Methods

sizeOf :: Int32 -> Int Source #

alignment :: Int32 -> Int Source #

peekElemOff :: Ptr Int32 -> Int -> IO Int32 Source #

pokeElemOff :: Ptr Int32 -> Int -> Int32 -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Int32 Source #

pokeByteOff :: Ptr b -> Int -> Int32 -> IO () Source #

peek :: Ptr Int32 -> IO Int32 Source #

poke :: Ptr Int32 -> Int32 -> IO () Source #

Storable Int64 | Since: base-2.1

Instance details

Defined in GHC.Internal.Foreign.Storable

Methods

sizeOf :: Int64 -> Int Source #

alignment :: Int64 -> Int Source #

peekElemOff :: Ptr Int64 -> Int -> IO Int64 Source #

pokeElemOff :: Ptr Int64 -> Int -> Int64 -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Int64 Source #

pokeByteOff :: Ptr b -> Int -> Int64 -> IO () Source #

peek :: Ptr Int64 -> IO Int64 Source #

poke :: Ptr Int64 -> Int64 -> IO () Source #

Storable Int8 | Since: base-2.1

Instance details

Defined in GHC.Internal.Foreign.Storable

Methods

sizeOf :: Int8 -> Int Source #

alignment :: Int8 -> Int Source #

peekElemOff :: Ptr Int8 -> Int -> IO Int8 Source #

pokeElemOff :: Ptr Int8 -> Int -> Int8 -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Int8 Source #

pokeByteOff :: Ptr b -> Int -> Int8 -> IO () Source #

peek :: Ptr Int8 -> IO Int8 Source #

poke :: Ptr Int8 -> Int8 -> IO () Source #

Storable IoSubSystem | Since: base-4.9.0.0

Instance details

Defined in GHC.Internal.RTS.Flags

Methods

sizeOf :: IoSubSystem -> Int Source #

alignment :: IoSubSystem -> Int Source #

peekElemOff :: Ptr IoSubSystem -> Int -> IO IoSubSystem Source #

pokeElemOff :: Ptr IoSubSystem -> Int -> IoSubSystem -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO IoSubSystem Source #

pokeByteOff :: Ptr b -> Int -> IoSubSystem -> IO () Source #

peek :: Ptr IoSubSystem -> IO IoSubSystem Source #

poke :: Ptr IoSubSystem -> IoSubSystem -> IO () Source #

Storable CBlkCnt |

Instance details

Defined in GHC.Internal.System.Posix.Types

Methods

sizeOf :: CBlkCnt -> Int Source #

alignment :: CBlkCnt -> Int Source #

peekElemOff :: Ptr CBlkCnt -> Int -> IO CBlkCnt Source #

pokeElemOff :: Ptr CBlkCnt -> Int -> CBlkCnt -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CBlkCnt Source #

pokeByteOff :: Ptr b -> Int -> CBlkCnt -> IO () Source #

peek :: Ptr CBlkCnt -> IO CBlkCnt Source #

poke :: Ptr CBlkCnt -> CBlkCnt -> IO () Source #

Storable CBlkSize |

Instance details

Defined in GHC.Internal.System.Posix.Types

Methods

sizeOf :: CBlkSize -> Int Source #

alignment :: CBlkSize -> Int Source #

peekElemOff :: Ptr CBlkSize -> Int -> IO CBlkSize Source #

pokeElemOff :: Ptr CBlkSize -> Int -> CBlkSize -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CBlkSize Source #

pokeByteOff :: Ptr b -> Int -> CBlkSize -> IO () Source #

peek :: Ptr CBlkSize -> IO CBlkSize Source #

poke :: Ptr CBlkSize -> CBlkSize -> IO () Source #

Storable CCc |

Instance details

Defined in GHC.Internal.System.Posix.Types

Methods

sizeOf :: CCc -> Int Source #

alignment :: CCc -> Int Source #

peekElemOff :: Ptr CCc -> Int -> IO CCc Source #

pokeElemOff :: Ptr CCc -> Int -> CCc -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CCc Source #

pokeByteOff :: Ptr b -> Int -> CCc -> IO () Source #

peek :: Ptr CCc -> IO CCc Source #

poke :: Ptr CCc -> CCc -> IO () Source #

Storable CClockId |

Instance details

Defined in GHC.Internal.System.Posix.Types

Methods

sizeOf :: CClockId -> Int Source #

alignment :: CClockId -> Int Source #

peekElemOff :: Ptr CClockId -> Int -> IO CClockId Source #

pokeElemOff :: Ptr CClockId -> Int -> CClockId -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CClockId Source #

pokeByteOff :: Ptr b -> Int -> CClockId -> IO () Source #

peek :: Ptr CClockId -> IO CClockId Source #

poke :: Ptr CClockId -> CClockId -> IO () Source #

Storable CDev |

Instance details

Defined in GHC.Internal.System.Posix.Types

Methods

sizeOf :: CDev -> Int Source #

alignment :: CDev -> Int Source #

peekElemOff :: Ptr CDev -> Int -> IO CDev Source #

pokeElemOff :: Ptr CDev -> Int -> CDev -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CDev Source #

pokeByteOff :: Ptr b -> Int -> CDev -> IO () Source #

peek :: Ptr CDev -> IO CDev Source #

poke :: Ptr CDev -> CDev -> IO () Source #

Storable CFsBlkCnt |

Instance details

Defined in GHC.Internal.System.Posix.Types

Methods

sizeOf :: CFsBlkCnt -> Int Source #

alignment :: CFsBlkCnt -> Int Source #

peekElemOff :: Ptr CFsBlkCnt -> Int -> IO CFsBlkCnt Source #

pokeElemOff :: Ptr CFsBlkCnt -> Int -> CFsBlkCnt -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CFsBlkCnt Source #

pokeByteOff :: Ptr b -> Int -> CFsBlkCnt -> IO () Source #

peek :: Ptr CFsBlkCnt -> IO CFsBlkCnt Source #

poke :: Ptr CFsBlkCnt -> CFsBlkCnt -> IO () Source #

Storable CFsFilCnt |

Instance details

Defined in GHC.Internal.System.Posix.Types

Methods

sizeOf :: CFsFilCnt -> Int Source #

alignment :: CFsFilCnt -> Int Source #

peekElemOff :: Ptr CFsFilCnt -> Int -> IO CFsFilCnt Source #

pokeElemOff :: Ptr CFsFilCnt -> Int -> CFsFilCnt -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CFsFilCnt Source #

pokeByteOff :: Ptr b -> Int -> CFsFilCnt -> IO () Source #

peek :: Ptr CFsFilCnt -> IO CFsFilCnt Source #

poke :: Ptr CFsFilCnt -> CFsFilCnt -> IO () Source #

Storable CGid |

Instance details

Defined in GHC.Internal.System.Posix.Types

Methods

sizeOf :: CGid -> Int Source #

alignment :: CGid -> Int Source #

peekElemOff :: Ptr CGid -> Int -> IO CGid Source #

pokeElemOff :: Ptr CGid -> Int -> CGid -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CGid Source #

pokeByteOff :: Ptr b -> Int -> CGid -> IO () Source #

peek :: Ptr CGid -> IO CGid Source #

poke :: Ptr CGid -> CGid -> IO () Source #

Storable CId |

Instance details

Defined in GHC.Internal.System.Posix.Types

Methods

sizeOf :: CId -> Int Source #

alignment :: CId -> Int Source #

peekElemOff :: Ptr CId -> Int -> IO CId Source #

pokeElemOff :: Ptr CId -> Int -> CId -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CId Source #

pokeByteOff :: Ptr b -> Int -> CId -> IO () Source #

peek :: Ptr CId -> IO CId Source #

poke :: Ptr CId -> CId -> IO () Source #

Storable CIno |

Instance details

Defined in GHC.Internal.System.Posix.Types

Methods

sizeOf :: CIno -> Int Source #

alignment :: CIno -> Int Source #

peekElemOff :: Ptr CIno -> Int -> IO CIno Source #

pokeElemOff :: Ptr CIno -> Int -> CIno -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CIno Source #

pokeByteOff :: Ptr b -> Int -> CIno -> IO () Source #

peek :: Ptr CIno -> IO CIno Source #

poke :: Ptr CIno -> CIno -> IO () Source #

Storable CKey |

Instance details

Defined in GHC.Internal.System.Posix.Types

Methods

sizeOf :: CKey -> Int Source #

alignment :: CKey -> Int Source #

peekElemOff :: Ptr CKey -> Int -> IO CKey Source #

pokeElemOff :: Ptr CKey -> Int -> CKey -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CKey Source #

pokeByteOff :: Ptr b -> Int -> CKey -> IO () Source #

peek :: Ptr CKey -> IO CKey Source #

poke :: Ptr CKey -> CKey -> IO () Source #

Storable CMode |

Instance details

Defined in GHC.Internal.System.Posix.Types

Methods

sizeOf :: CMode -> Int Source #

alignment :: CMode -> Int Source #

peekElemOff :: Ptr CMode -> Int -> IO CMode Source #

pokeElemOff :: Ptr CMode -> Int -> CMode -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CMode Source #

pokeByteOff :: Ptr b -> Int -> CMode -> IO () Source #

peek :: Ptr CMode -> IO CMode Source #

poke :: Ptr CMode -> CMode -> IO () Source #

Storable CNfds |

Instance details

Defined in GHC.Internal.System.Posix.Types

Methods

sizeOf :: CNfds -> Int Source #

alignment :: CNfds -> Int Source #

peekElemOff :: Ptr CNfds -> Int -> IO CNfds Source #

pokeElemOff :: Ptr CNfds -> Int -> CNfds -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CNfds Source #

pokeByteOff :: Ptr b -> Int -> CNfds -> IO () Source #

peek :: Ptr CNfds -> IO CNfds Source #

poke :: Ptr CNfds -> CNfds -> IO () Source #

Storable CNlink |

Instance details

Defined in GHC.Internal.System.Posix.Types

Methods

sizeOf :: CNlink -> Int Source #

alignment :: CNlink -> Int Source #

peekElemOff :: Ptr CNlink -> Int -> IO CNlink Source #

pokeElemOff :: Ptr CNlink -> Int -> CNlink -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CNlink Source #

pokeByteOff :: Ptr b -> Int -> CNlink -> IO () Source #

peek :: Ptr CNlink -> IO CNlink Source #

poke :: Ptr CNlink -> CNlink -> IO () Source #

Storable COff |

Instance details

Defined in GHC.Internal.System.Posix.Types

Methods

sizeOf :: COff -> Int Source #

alignment :: COff -> Int Source #

peekElemOff :: Ptr COff -> Int -> IO COff Source #

pokeElemOff :: Ptr COff -> Int -> COff -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO COff Source #

pokeByteOff :: Ptr b -> Int -> COff -> IO () Source #

peek :: Ptr COff -> IO COff Source #

poke :: Ptr COff -> COff -> IO () Source #

Storable CPid |

Instance details

Defined in GHC.Internal.System.Posix.Types

Methods

sizeOf :: CPid -> Int Source #

alignment :: CPid -> Int Source #

peekElemOff :: Ptr CPid -> Int -> IO CPid Source #

pokeElemOff :: Ptr CPid -> Int -> CPid -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CPid Source #

pokeByteOff :: Ptr b -> Int -> CPid -> IO () Source #

peek :: Ptr CPid -> IO CPid Source #

poke :: Ptr CPid -> CPid -> IO () Source #

Storable CRLim |

Instance details

Defined in GHC.Internal.System.Posix.Types

Methods

sizeOf :: CRLim -> Int Source #

alignment :: CRLim -> Int Source #

peekElemOff :: Ptr CRLim -> Int -> IO CRLim Source #

pokeElemOff :: Ptr CRLim -> Int -> CRLim -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CRLim Source #

pokeByteOff :: Ptr b -> Int -> CRLim -> IO () Source #

peek :: Ptr CRLim -> IO CRLim Source #

poke :: Ptr CRLim -> CRLim -> IO () Source #

Storable CSocklen |

Instance details

Defined in GHC.Internal.System.Posix.Types

Methods

sizeOf :: CSocklen -> Int Source #

alignment :: CSocklen -> Int Source #

peekElemOff :: Ptr CSocklen -> Int -> IO CSocklen Source #

pokeElemOff :: Ptr CSocklen -> Int -> CSocklen -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CSocklen Source #

pokeByteOff :: Ptr b -> Int -> CSocklen -> IO () Source #

peek :: Ptr CSocklen -> IO CSocklen Source #

poke :: Ptr CSocklen -> CSocklen -> IO () Source #

Storable CSpeed |

Instance details

Defined in GHC.Internal.System.Posix.Types

Methods

sizeOf :: CSpeed -> Int Source #

alignment :: CSpeed -> Int Source #

peekElemOff :: Ptr CSpeed -> Int -> IO CSpeed Source #

pokeElemOff :: Ptr CSpeed -> Int -> CSpeed -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CSpeed Source #

pokeByteOff :: Ptr b -> Int -> CSpeed -> IO () Source #

peek :: Ptr CSpeed -> IO CSpeed Source #

poke :: Ptr CSpeed -> CSpeed -> IO () Source #

Storable CSsize |

Instance details

Defined in GHC.Internal.System.Posix.Types

Methods

sizeOf :: CSsize -> Int Source #

alignment :: CSsize -> Int Source #

peekElemOff :: Ptr CSsize -> Int -> IO CSsize Source #

pokeElemOff :: Ptr CSsize -> Int -> CSsize -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CSsize Source #

pokeByteOff :: Ptr b -> Int -> CSsize -> IO () Source #

peek :: Ptr CSsize -> IO CSsize Source #

poke :: Ptr CSsize -> CSsize -> IO () Source #

Storable CTcflag |

Instance details

Defined in GHC.Internal.System.Posix.Types

Methods

sizeOf :: CTcflag -> Int Source #

alignment :: CTcflag -> Int Source #

peekElemOff :: Ptr CTcflag -> Int -> IO CTcflag Source #

pokeElemOff :: Ptr CTcflag -> Int -> CTcflag -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CTcflag Source #

pokeByteOff :: Ptr b -> Int -> CTcflag -> IO () Source #

peek :: Ptr CTcflag -> IO CTcflag Source #

poke :: Ptr CTcflag -> CTcflag -> IO () Source #

Storable CTimer |

Instance details

Defined in GHC.Internal.System.Posix.Types

Methods

sizeOf :: CTimer -> Int Source #

alignment :: CTimer -> Int Source #

peekElemOff :: Ptr CTimer -> Int -> IO CTimer Source #

pokeElemOff :: Ptr CTimer -> Int -> CTimer -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CTimer Source #

pokeByteOff :: Ptr b -> Int -> CTimer -> IO () Source #

peek :: Ptr CTimer -> IO CTimer Source #

poke :: Ptr CTimer -> CTimer -> IO () Source #

Storable CUid |

Instance details

Defined in GHC.Internal.System.Posix.Types

Methods

sizeOf :: CUid -> Int Source #

alignment :: CUid -> Int Source #

peekElemOff :: Ptr CUid -> Int -> IO CUid Source #

pokeElemOff :: Ptr CUid -> Int -> CUid -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CUid Source #

pokeByteOff :: Ptr b -> Int -> CUid -> IO () Source #

peek :: Ptr CUid -> IO CUid Source #

poke :: Ptr CUid -> CUid -> IO () Source #

Storable Fd |
Instance details Defined in GHC.Internal.System.Posix.Types Methods sizeOf :: Fd -> Int Source # alignment :: Fd -> Int Source # peekElemOff :: Ptr Fd -> Int -> IO Fd Source # pokeElemOff :: Ptr Fd -> Int -> Fd -> IO () Source # peekByteOff :: Ptr b -> Int -> IO Fd Source # pokeByteOff :: Ptr b -> Int -> Fd -> IO () Source # peek :: Ptr Fd -> IO Fd Source # poke :: Ptr Fd -> Fd -> IO () Source #
Storable Word16 | Since: base-2.1

Instance details

Defined in GHC.Internal.Foreign.Storable

Methods

sizeOf :: Word16 -> Int Source #

alignment :: Word16 -> Int Source #

peekElemOff :: Ptr Word16 -> Int -> IO Word16 Source #

pokeElemOff :: Ptr Word16 -> Int -> Word16 -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Word16 Source #

pokeByteOff :: Ptr b -> Int -> Word16 -> IO () Source #

peek :: Ptr Word16 -> IO Word16 Source #

poke :: Ptr Word16 -> Word16 -> IO () Source #

Storable Word32 | Since: base-2.1

Instance details

Defined in GHC.Internal.Foreign.Storable

Methods

sizeOf :: Word32 -> Int Source #

alignment :: Word32 -> Int Source #

peekElemOff :: Ptr Word32 -> Int -> IO Word32 Source #

pokeElemOff :: Ptr Word32 -> Int -> Word32 -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Word32 Source #

pokeByteOff :: Ptr b -> Int -> Word32 -> IO () Source #

peek :: Ptr Word32 -> IO Word32 Source #

poke :: Ptr Word32 -> Word32 -> IO () Source #

Storable Word64 | Since: base-2.1

Instance details

Defined in GHC.Internal.Foreign.Storable

Methods

sizeOf :: Word64 -> Int Source #

alignment :: Word64 -> Int Source #

peekElemOff :: Ptr Word64 -> Int -> IO Word64 Source #

pokeElemOff :: Ptr Word64 -> Int -> Word64 -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Word64 Source #

pokeByteOff :: Ptr b -> Int -> Word64 -> IO () Source #

peek :: Ptr Word64 -> IO Word64 Source #

poke :: Ptr Word64 -> Word64 -> IO () Source #

Storable Word8 | Since: base-2.1

Instance details

Defined in GHC.Internal.Foreign.Storable

Methods

sizeOf :: Word8 -> Int Source #

alignment :: Word8 -> Int Source #

peekElemOff :: Ptr Word8 -> Int -> IO Word8 Source #

pokeElemOff :: Ptr Word8 -> Int -> Word8 -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Word8 Source #

pokeByteOff :: Ptr b -> Int -> Word8 -> IO () Source #

peek :: Ptr Word8 -> IO Word8 Source #

poke :: Ptr Word8 -> Word8 -> IO () Source #

Storable () | Since: base-4.9.0.0
Instance details Defined in GHC.Internal.Foreign.Storable Methods sizeOf :: () -> Int Source # alignment :: () -> Int Source # peekElemOff :: Ptr () -> Int -> IO () Source # pokeElemOff :: Ptr () -> Int -> () -> IO () Source # peekByteOff :: Ptr b -> Int -> IO () Source # pokeByteOff :: Ptr b -> Int -> () -> IO () Source # peek :: Ptr () -> IO () Source # poke :: Ptr () -> () -> IO () Source #
Storable Bool | Since: base-2.1

Instance details

Defined in GHC.Internal.Foreign.Storable

Methods

sizeOf :: Bool -> Int Source #

alignment :: Bool -> Int Source #

peekElemOff :: Ptr Bool -> Int -> IO Bool Source #

pokeElemOff :: Ptr Bool -> Int -> Bool -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Bool Source #

pokeByteOff :: Ptr b -> Int -> Bool -> IO () Source #

peek :: Ptr Bool -> IO Bool Source #

poke :: Ptr Bool -> Bool -> IO () Source #

Storable Char | Since: base-2.1

Instance details

Defined in GHC.Internal.Foreign.Storable

Methods

sizeOf :: Char -> Int Source #

alignment :: Char -> Int Source #

peekElemOff :: Ptr Char -> Int -> IO Char Source #

pokeElemOff :: Ptr Char -> Int -> Char -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Char Source #

pokeByteOff :: Ptr b -> Int -> Char -> IO () Source #

peek :: Ptr Char -> IO Char Source #

poke :: Ptr Char -> Char -> IO () Source #

Storable Double | Since: base-2.1

Instance details

Defined in GHC.Internal.Foreign.Storable

Methods

sizeOf :: Double -> Int Source #

alignment :: Double -> Int Source #

peekElemOff :: Ptr Double -> Int -> IO Double Source #

pokeElemOff :: Ptr Double -> Int -> Double -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Double Source #

pokeByteOff :: Ptr b -> Int -> Double -> IO () Source #

peek :: Ptr Double -> IO Double Source #

poke :: Ptr Double -> Double -> IO () Source #

Storable Float | Since: base-2.1

Instance details

Defined in GHC.Internal.Foreign.Storable

Methods

sizeOf :: Float -> Int Source #

alignment :: Float -> Int Source #

peekElemOff :: Ptr Float -> Int -> IO Float Source #

pokeElemOff :: Ptr Float -> Int -> Float -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Float Source #

pokeByteOff :: Ptr b -> Int -> Float -> IO () Source #

peek :: Ptr Float -> IO Float Source #

poke :: Ptr Float -> Float -> IO () Source #

Storable Int | Since: base-2.1

Instance details

Defined in GHC.Internal.Foreign.Storable

Methods

sizeOf :: Int -> Int Source #

alignment :: Int -> Int Source #

peekElemOff :: Ptr Int -> Int -> IO Int Source #

pokeElemOff :: Ptr Int -> Int -> Int -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Int Source #

pokeByteOff :: Ptr b -> Int -> Int -> IO () Source #

peek :: Ptr Int -> IO Int Source #

poke :: Ptr Int -> Int -> IO () Source #

Storable Word | Since: base-2.1

Instance details

Defined in GHC.Internal.Foreign.Storable

Methods

sizeOf :: Word -> Int Source #

alignment :: Word -> Int Source #

peekElemOff :: Ptr Word -> Int -> IO Word Source #

pokeElemOff :: Ptr Word -> Int -> Word -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Word Source #

pokeByteOff :: Ptr b -> Int -> Word -> IO () Source #

peek :: Ptr Word -> IO Word Source #

poke :: Ptr Word -> Word -> IO () Source #

Storable a => Storable (Complex a) | Since: base-4.8.0.0

Instance details

Defined in Data.Complex

Methods

sizeOf :: Complex a -> Int Source #

alignment :: Complex a -> Int Source #

peekElemOff :: Ptr (Complex a) -> Int -> IO (Complex a) Source #

pokeElemOff :: Ptr (Complex a) -> Int -> Complex a -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO (Complex a) Source #

pokeByteOff :: Ptr b -> Int -> Complex a -> IO () Source #

peek :: Ptr (Complex a) -> IO (Complex a) Source #

poke :: Ptr (Complex a) -> Complex a -> IO () Source #

Storable a => Storable (Identity a) | Since: base-4.9.0.0

Instance details

Defined in GHC.Internal.Data.Functor.Identity

Methods

sizeOf :: Identity a -> Int Source #

alignment :: Identity a -> Int Source #

peekElemOff :: Ptr (Identity a) -> Int -> IO (Identity a) Source #

pokeElemOff :: Ptr (Identity a) -> Int -> Identity a -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO (Identity a) Source #

pokeByteOff :: Ptr b -> Int -> Identity a -> IO () Source #

peek :: Ptr (Identity a) -> IO (Identity a) Source #

poke :: Ptr (Identity a) -> Identity a -> IO () Source #

Storable a => Storable (Down a) | Since: base-4.14.0.0

Instance details

Defined in GHC.Internal.Data.Ord

Methods

sizeOf :: Down a -> Int Source #

alignment :: Down a -> Int Source #

peekElemOff :: Ptr (Down a) -> Int -> IO (Down a) Source #

pokeElemOff :: Ptr (Down a) -> Int -> Down a -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO (Down a) Source #

pokeByteOff :: Ptr b -> Int -> Down a -> IO () Source #

peek :: Ptr (Down a) -> IO (Down a) Source #

poke :: Ptr (Down a) -> Down a -> IO () Source #

Storable (ConstPtr a) |

Instance details

Defined in GHC.Internal.Foreign.Storable

Methods

sizeOf :: ConstPtr a -> Int Source #

alignment :: ConstPtr a -> Int Source #

peekElemOff :: Ptr (ConstPtr a) -> Int -> IO (ConstPtr a) Source #

pokeElemOff :: Ptr (ConstPtr a) -> Int -> ConstPtr a -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO (ConstPtr a) Source #

pokeByteOff :: Ptr b -> Int -> ConstPtr a -> IO () Source #

peek :: Ptr (ConstPtr a) -> IO (ConstPtr a) Source #

poke :: Ptr (ConstPtr a) -> ConstPtr a -> IO () Source #

Storable (FunPtr a) | Since: base-2.1

Instance details

Defined in GHC.Internal.Foreign.Storable

Methods

sizeOf :: FunPtr a -> Int Source #

alignment :: FunPtr a -> Int Source #

peekElemOff :: Ptr (FunPtr a) -> Int -> IO (FunPtr a) Source #

pokeElemOff :: Ptr (FunPtr a) -> Int -> FunPtr a -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO (FunPtr a) Source #

pokeByteOff :: Ptr b -> Int -> FunPtr a -> IO () Source #

peek :: Ptr (FunPtr a) -> IO (FunPtr a) Source #

poke :: Ptr (FunPtr a) -> FunPtr a -> IO () Source #

Storable (Ptr a) | Since: base-2.1

Instance details

Defined in GHC.Internal.Foreign.Storable

Methods

sizeOf :: Ptr a -> Int Source #

alignment :: Ptr a -> Int Source #

peekElemOff :: Ptr (Ptr a) -> Int -> IO (Ptr a) Source #

pokeElemOff :: Ptr (Ptr a) -> Int -> Ptr a -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO (Ptr a) Source #

pokeByteOff :: Ptr b -> Int -> Ptr a -> IO () Source #

peek :: Ptr (Ptr a) -> IO (Ptr a) Source #

poke :: Ptr (Ptr a) -> Ptr a -> IO () Source #

(Storable a, Integral a) => Storable (Ratio a) | Since: base-4.8.0.0

Instance details

Defined in GHC.Internal.Foreign.Storable

Methods

sizeOf :: Ratio a -> Int Source #

alignment :: Ratio a -> Int Source #

peekElemOff :: Ptr (Ratio a) -> Int -> IO (Ratio a) Source #

pokeElemOff :: Ptr (Ratio a) -> Int -> Ratio a -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO (Ratio a) Source #

pokeByteOff :: Ptr b -> Int -> Ratio a -> IO () Source #

peek :: Ptr (Ratio a) -> IO (Ratio a) Source #

poke :: Ptr (Ratio a) -> Ratio a -> IO () Source #

Storable (StablePtr a) | Since: base-2.1

Instance details

Defined in GHC.Internal.Foreign.Storable

Methods

sizeOf :: StablePtr a -> Int Source #

alignment :: StablePtr a -> Int Source #

peekElemOff :: Ptr (StablePtr a) -> Int -> IO (StablePtr a) Source #

pokeElemOff :: Ptr (StablePtr a) -> Int -> StablePtr a -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO (StablePtr a) Source #

pokeByteOff :: Ptr b -> Int -> StablePtr a -> IO () Source #

peek :: Ptr (StablePtr a) -> IO (StablePtr a) Source #

poke :: Ptr (StablePtr a) -> StablePtr a -> IO () Source #

Prim a => Storable (PrimStorable a) |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOf :: PrimStorable a -> Int Source #

alignment :: PrimStorable a -> Int Source #

peekElemOff :: Ptr (PrimStorable a) -> Int -> IO (PrimStorable a) Source #

pokeElemOff :: Ptr (PrimStorable a) -> Int -> PrimStorable a -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO (PrimStorable a) Source #

pokeByteOff :: Ptr b -> Int -> PrimStorable a -> IO () Source #

peek :: Ptr (PrimStorable a) -> IO (PrimStorable a) Source #

poke :: Ptr (PrimStorable a) -> PrimStorable a -> IO () Source #

Storable a => Storable (Const a b) | Since: base-4.9.0.0

Instance details

Defined in GHC.Internal.Data.Functor.Const

Methods

sizeOf :: Const a b -> Int Source #

alignment :: Const a b -> Int Source #

peekElemOff :: Ptr (Const a b) -> Int -> IO (Const a b) Source #

pokeElemOff :: Ptr (Const a b) -> Int -> Const a b -> IO () Source #

peekByteOff :: Ptr b0 -> Int -> IO (Const a b) Source #

pokeByteOff :: Ptr b0 -> Int -> Const a b -> IO () Source #

peek :: Ptr (Const a b) -> IO (Const a b) Source #

poke :: Ptr (Const a b) -> Const a b -> IO () Source #

class Monad m => PrimMonad (m :: Type -> Type) Source #

Class of monads which can perform primitive state-transformer actions.

Minimal complete definition

primitive

#### Instances

Instances details

PrimMonad IO |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState IO |
Instance details Defined in Control.Monad.Primitive type PrimState IO = RealWorld

Methods

primitive :: (State# (PrimState IO) -> (# State# (PrimState IO), a #)) -> IO a Source #

PrimMonad (ST s) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (ST s) |
Instance details Defined in Control.Monad.Primitive type PrimState (ST s) = s

Methods

primitive :: (State# (PrimState (ST s)) -> (# State# (PrimState (ST s)), a #)) -> ST s a Source #

PrimMonad (ST s) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (ST s) |
Instance details Defined in Control.Monad.Primitive type PrimState (ST s) = s

Methods

primitive :: (State# (PrimState (ST s)) -> (# State# (PrimState (ST s)), a #)) -> ST s a Source #

PrimMonad m => PrimMonad (MaybeT m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (MaybeT m) |
Instance details Defined in Control.Monad.Primitive type PrimState (MaybeT m) = PrimState m

Methods

primitive :: (State# (PrimState (MaybeT m)) -> (# State# (PrimState (MaybeT m)), a #)) -> MaybeT m a Source #

(Monoid w, PrimMonad m) => PrimMonad (AccumT w m) | Since: primitive-0.6.3.0

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (AccumT w m) |
Instance details Defined in Control.Monad.Primitive type PrimState (AccumT w m) = PrimState m

Methods

primitive :: (State# (PrimState (AccumT w m)) -> (# State# (PrimState (AccumT w m)), a #)) -> AccumT w m a Source #

PrimMonad m => PrimMonad (ExceptT e m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (ExceptT e m) |
Instance details Defined in Control.Monad.Primitive type PrimState (ExceptT e m) = PrimState m

Methods

primitive :: (State# (PrimState (ExceptT e m)) -> (# State# (PrimState (ExceptT e m)), a #)) -> ExceptT e m a Source #

PrimMonad m => PrimMonad (IdentityT m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (IdentityT m) |
Instance details Defined in Control.Monad.Primitive type PrimState (IdentityT m) = PrimState m

Methods

primitive :: (State# (PrimState (IdentityT m)) -> (# State# (PrimState (IdentityT m)), a #)) -> IdentityT m a Source #

PrimMonad m => PrimMonad (ReaderT r m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (ReaderT r m) |
Instance details Defined in Control.Monad.Primitive type PrimState (ReaderT r m) = PrimState m

Methods

primitive :: (State# (PrimState (ReaderT r m)) -> (# State# (PrimState (ReaderT r m)), a #)) -> ReaderT r m a Source #

PrimMonad m => PrimMonad (SelectT r m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (SelectT r m) |
Instance details Defined in Control.Monad.Primitive type PrimState (SelectT r m) = PrimState m

Methods

primitive :: (State# (PrimState (SelectT r m)) -> (# State# (PrimState (SelectT r m)), a #)) -> SelectT r m a Source #

PrimMonad m => PrimMonad (StateT s m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (StateT s m) |
Instance details Defined in Control.Monad.Primitive type PrimState (StateT s m) = PrimState m

Methods

primitive :: (State# (PrimState (StateT s m)) -> (# State# (PrimState (StateT s m)), a #)) -> StateT s m a Source #

PrimMonad m => PrimMonad (StateT s m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (StateT s m) |
Instance details Defined in Control.Monad.Primitive type PrimState (StateT s m) = PrimState m

Methods

primitive :: (State# (PrimState (StateT s m)) -> (# State# (PrimState (StateT s m)), a #)) -> StateT s m a Source #

(Monoid w, PrimMonad m) => PrimMonad (WriterT w m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (WriterT w m) |
Instance details Defined in Control.Monad.Primitive type PrimState (WriterT w m) = PrimState m

Methods

primitive :: (State# (PrimState (WriterT w m)) -> (# State# (PrimState (WriterT w m)), a #)) -> WriterT w m a Source #

(Monoid w, PrimMonad m) => PrimMonad (WriterT w m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (WriterT w m) |
Instance details Defined in Control.Monad.Primitive type PrimState (WriterT w m) = PrimState m

Methods

primitive :: (State# (PrimState (WriterT w m)) -> (# State# (PrimState (WriterT w m)), a #)) -> WriterT w m a Source #

(Monoid w, PrimMonad m) => PrimMonad (WriterT w m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (WriterT w m) |
Instance details Defined in Control.Monad.Primitive type PrimState (WriterT w m) = PrimState m

Methods

primitive :: (State# (PrimState (WriterT w m)) -> (# State# (PrimState (WriterT w m)), a #)) -> WriterT w m a Source #

PrimMonad m => PrimMonad (ContT r m) | Since: primitive-0.6.3.0

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (ContT r m) |
Instance details Defined in Control.Monad.Primitive type PrimState (ContT r m) = PrimState m

Methods

primitive :: (State# (PrimState (ContT r m)) -> (# State# (PrimState (ContT r m)), a #)) -> ContT r m a Source #

(Monoid w, PrimMonad m) => PrimMonad (RWST r w s m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (RWST r w s m) |
Instance details Defined in Control.Monad.Primitive type PrimState (RWST r w s m) = PrimState m

Methods

primitive :: (State# (PrimState (RWST r w s m)) -> (# State# (PrimState (RWST r w s m)), a #)) -> RWST r w s m a Source #

(Monoid w, PrimMonad m) => PrimMonad (RWST r w s m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (RWST r w s m) |
Instance details Defined in Control.Monad.Primitive type PrimState (RWST r w s m) = PrimState m

Methods

primitive :: (State# (PrimState (RWST r w s m)) -> (# State# (PrimState (RWST r w s m)), a #)) -> RWST r w s m a Source #

(Monoid w, PrimMonad m) => PrimMonad (RWST r w s m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (RWST r w s m) |
Instance details Defined in Control.Monad.Primitive type PrimState (RWST r w s m) = PrimState m

Methods

primitive :: (State# (PrimState (RWST r w s m)) -> (# State# (PrimState (RWST r w s m)), a #)) -> RWST r w s m a Source #

type family PrimState (m :: Type -> Type) Source #

State token type.

#### Instances

Instances details

type PrimState IO |
Instance details Defined in Control.Monad.Primitive type PrimState IO = RealWorld
type PrimState (ST s) |
Instance details Defined in Control.Monad.Primitive type PrimState (ST s) = s
type PrimState (ST s) |
Instance details Defined in Control.Monad.Primitive type PrimState (ST s) = s
type PrimState (MaybeT m) |
Instance details Defined in Control.Monad.Primitive type PrimState (MaybeT m) = PrimState m
type PrimState (AccumT w m) |
Instance details Defined in Control.Monad.Primitive type PrimState (AccumT w m) = PrimState m
type PrimState (ExceptT e m) |
Instance details Defined in Control.Monad.Primitive type PrimState (ExceptT e m) = PrimState m
type PrimState (IdentityT m) |
Instance details Defined in Control.Monad.Primitive type PrimState (IdentityT m) = PrimState m
type PrimState (ReaderT r m) |
Instance details Defined in Control.Monad.Primitive type PrimState (ReaderT r m) = PrimState m
type PrimState (SelectT r m) |
Instance details Defined in Control.Monad.Primitive type PrimState (SelectT r m) = PrimState m
type PrimState (StateT s m) |
Instance details Defined in Control.Monad.Primitive type PrimState (StateT s m) = PrimState m
type PrimState (StateT s m) |
Instance details Defined in Control.Monad.Primitive type PrimState (StateT s m) = PrimState m
type PrimState (WriterT w m) |
Instance details Defined in Control.Monad.Primitive type PrimState (WriterT w m) = PrimState m
type PrimState (WriterT w m) |
Instance details Defined in Control.Monad.Primitive type PrimState (WriterT w m) = PrimState m
type PrimState (WriterT w m) |
Instance details Defined in Control.Monad.Primitive type PrimState (WriterT w m) = PrimState m
type PrimState (ContT r m) |
Instance details Defined in Control.Monad.Primitive type PrimState (ContT r m) = PrimState m
type PrimState (RWST r w s m) |
Instance details Defined in Control.Monad.Primitive type PrimState (RWST r w s m) = PrimState m
type PrimState (RWST r w s m) |
Instance details Defined in Control.Monad.Primitive type PrimState (RWST r w s m) = PrimState m
type PrimState (RWST r w s m) |
Instance details Defined in Control.Monad.Primitive type PrimState (RWST r w s m) = PrimState m

data RealWorld Source #

`RealWorld` is deeply magical. It is primitive, but it is not unlifted (hence `ptrArg`). We never manipulate values of type `RealWorld`; it's only used in the type system, to parameterise `State#`.